package net.moonleay.mods.gimble.mixin;

import net.minecraft.client.MinecraftClient;
import net.moonleay.mods.gimble.client.editor.Editor;
import net.moonleay.mods.gimble.client.editor.modes.Mode;
import org.spongepowered.asm.mixin.Mixin;
import org.spongepowered.asm.mixin.injection.At;
import org.spongepowered.asm.mixin.injection.Inject;
import org.spongepowered.asm.mixin.injection.callback.CallbackInfo;

@Mixin(MinecraftClient.class)
public class NormalModeMixin {

    @Inject(method = "openPauseMenu", at = @At("HEAD"), cancellable = true)
    private void setNormalMode(boolean pause, CallbackInfo ci) {
        if (Editor.INSTANCE.getCURRENT_MODE() != Mode.NORMAL){
            // Set the editor mode to normal
            Editor.INSTANCE.setCURRENT_MODE(Mode.NORMAL);
            Editor.INSTANCE.checkForIncompatibleModeModifiers();
            ci.cancel();
        }
    }
}
